//+------------------------------------------------------------------+
//|                                                    TL_Vik_19.mq4 |
//|                                                  A.Lopatin 2007 |
//|                                             http://www.fxprog.ru |
//+------------------------------------------------------------------+
#property copyright "A.Lopatin 2007"
#property link      "http://www.fxprog.ru"

#property indicator_chart_window
#include <stdlib.mqh>

#define VER "19"
#define _UP_TREND_ 1
#define _DOWN_TREND_ -1

extern int TimeFrame=1440;
extern color UpTrendLineColor=DodgerBlue;
extern color DownTrendLineColor=DodgerBlue;
extern int UpTrendLineWidth=1;
extern int DownTrendLineWidth=1;

string utl1_name,dtl1_name;

datetime GetBarTime(datetime time,double value,int mode)
{
   int n=TimeFrame/Period();
   if(n==1)
      return(time);
   datetime retn_time=0;
   int start=iBarShift(NULL,Period(),time,false),
       bar_shift=iBarShift(NULL,TimeFrame,time);
   double price=0;
   int delta=2;
   if(TimeFrame==PERIOD_D1)
      delta=4;
  
   for(int i=start-n;i<=start;i++)
   {
      if(mode==-1)
         price=Low[i];
      if(mode==1)
         price=High[i];
      if(MathAbs(value-price)<delta*Point&&iBarShift(NULL,TimeFrame,Time[i])==bar_shift&&bar_shift>=0)
      {
         retn_time=Time[i];
         break;
      }
   }
   return(retn_time);
}

double GetLineValue(double b,int a,int x,double k)
{
   return(b+(a-x)*k);
}

bool PriceCross(double price1,double price2,datetime time1,datetime time2,int mode)
{
   int shift1=iBarShift(NULL,TimeFrame,time1,false);
   int shift2=iBarShift(NULL,TimeFrame,time2,false);
   double k=(price2-price1)/(shift1-shift2);
   bool ret=false;
   
   for(int i=shift1;i>=shift2;i--)
   {
      if(mode==-1)
      {
         if((GetLineValue(price1,shift1,i,k)-iLow(NULL,TimeFrame,i))>0)
         {
            ret=true;
            break;
         }
      }
      else if(mode==1)
      {
         if((iHigh(NULL,TimeFrame,i)-GetLineValue(price1,shift1,i,k))>0)
         {
            ret=true;
            break;
         }
      }
   }
   return(ret);
}

bool DrawLine(string name,int type,datetime time1,double price1,datetime time2,double price2,color line_color,int line_width=1,int line_style=STYLE_SOLID)
{
    bool retn=false;
    if(ObjectFind(name)==-1)
    {
      ObjectCreate(name,type,0,time1,price1,time2,price2);
      ObjectSet(name,OBJPROP_COLOR,line_color);
      ObjectSet(name,OBJPROP_WIDTH,line_width);
      retn=ObjectSet(name,OBJPROP_STYLE,line_style);
    }
    else
    { 
      ObjectSet(name,OBJPROP_TIME1,time1);
      ObjectSet(name,OBJPROP_PRICE1,price1);
      ObjectSet(name,OBJPROP_TIME2,time2);
      ObjectSet(name,OBJPROP_PRICE2,price2);
      ObjectSet(name,OBJPROP_COLOR,line_color);
      ObjectSet(name,OBJPROP_STYLE,line_style);
      retn=ObjectSet(name,OBJPROP_WIDTH,line_width);
    }
    return(retn);
}

bool TrendLine(int trend,int start_shift,int end_shift)
{
      int start=start_shift;
      bool draw_line=false;
      int fr_mode=-1,i,j,tr=0;
      double price1,price2;
      datetime time1,time2;
      if(trend==_UP_TREND_)
         fr_mode=MODE_LOWER;
      else if(trend==_DOWN_TREND_)
         fr_mode=MODE_UPPER;
         
      while(start<=end_shift)
      {
         for(i=start;i<=end_shift;i++)
         {
            if(iFractals(NULL,TimeFrame,fr_mode,i)>0)
               break;
         }
         if(trend==_UP_TREND_)
            price2=iLow(NULL,TimeFrame,i);
         else if(trend==_DOWN_TREND_)
            price2=iHigh(NULL,TimeFrame,i);
         time2=iTime(NULL,TimeFrame,i);
         for(j=end_shift;j>i+1;j--)
         {
            if(trend==_UP_TREND_)
               price1=iLow(NULL,TimeFrame,j);
            else if(trend==_DOWN_TREND_)
               price1=iHigh(NULL,TimeFrame,j);
            time1=iTime(NULL,TimeFrame,j);
            if(time1>0&&time2>0)
            {
               if(trend==_UP_TREND_&&price1<price2)
               {
                  if(!PriceCross(price1,price2,time1,time2,-1))
                  {
                     draw_line=true;
                     break;
                  }
               }
               else if(trend==_DOWN_TREND_&&price1>price2)
               {
                  if(!PriceCross(price1,price2,time1,time2,1))
                  {
                     draw_line=true;
                     break;
                  }
               }  
            }
         }
         if(draw_line)
            break;
         start=i+1;
      } 
      if(draw_line)
      {
          if(trend==_UP_TREND_)
          {
            time1=GetBarTime(time1,price1,-1);
            time2=GetBarTime(time2,price2,-1);
            if(time1>0&&time2>0)
            {
               draw_line=DrawLine(utl1_name,OBJ_TREND,time1,price1,time2,price2,UpTrendLineColor,
                                  UpTrendLineWidth);
               if(draw_line)
                  ObjectDelete(dtl1_name);
            }
          } 
          else if(trend==_DOWN_TREND_)
          {
            time1=GetBarTime(time1,price1,1);
            time2=GetBarTime(time2,price2,1);
            if(time1>0&&time2>0)
            {
               draw_line=DrawLine(dtl1_name,OBJ_TREND,time1,price1,time2,price2,DownTrendLineColor,
                                  DownTrendLineWidth);
               if(draw_line)
                  ObjectDelete(utl1_name);
            }
          }
      }
     
      return(draw_line);
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   utl1_name="UpTrendLine1_"+VER+"_"+TimeFrame;
   dtl1_name="DownTrendLine1_"+VER+"_"+TimeFrame;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   if(ObjectFind(utl1_name)==0)
      ObjectDelete(utl1_name);
   if(ObjectFind(dtl1_name)==0)
      ObjectDelete(dtl1_name);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if(Period()>TimeFrame)
   {
      if(ObjectFind(utl1_name)==0)
         ObjectDelete(utl1_name);
      if(ObjectFind(dtl1_name)==0)
         ObjectDelete(dtl1_name);
      return(0);
   }
   
   int up_fract=0,down_fract=0,next_tf=0,left_shift=0,right_shift=0,trend=0,i,st_fract=1;
   bool draw_line=false;
   double line_val=0;
   datetime p_time=0;
  
  switch(TimeFrame)
   {
      case PERIOD_M1:
         next_tf=PERIOD_H1;
         break;
      case PERIOD_M5:
         next_tf=PERIOD_H1;
         break;
      case PERIOD_M15:
         next_tf=PERIOD_H1;
         break;
      case PERIOD_M30:
         next_tf=PERIOD_H1;
         break;
      case PERIOD_H1:
         next_tf=PERIOD_D1;
         break;
      case PERIOD_H4:
         next_tf=PERIOD_D1;
         st_fract=1;
         break;
      case PERIOD_D1:
         next_tf=PERIOD_W1;
         st_fract=1;
         break;
      case PERIOD_W1:
         next_tf=PERIOD_MN1;
         st_fract=4;
         break;
      default:
         next_tf=0;
         break;
   }
   
   for(i=st_fract;i<60;i++)
   {
      if(iFractals(NULL,next_tf,MODE_UPPER,i)>0&&up_fract==0)
      {
         up_fract=i;
         continue;
      }
      if(iFractals(NULL,next_tf,MODE_LOWER,i)>0&&down_fract==0)
         down_fract=i;
      if(up_fract>0&&down_fract>0)
         break;
   }
   
   if(up_fract>=down_fract&&down_fract>0)
   {
      left_shift=iBarShift(NULL,TimeFrame,iTime(NULL,next_tf,down_fract));
      left_shift=iLowest(NULL,TimeFrame,MODE_LOW,left_shift,0);
      right_shift=iHighest(NULL,TimeFrame,MODE_HIGH,left_shift,0);
      if(TrendLine(_UP_TREND_,right_shift,left_shift))
         trend=_UP_TREND_;
   }
   else if(up_fract<down_fract&&up_fract>0)
   { 
      left_shift=iBarShift(NULL,TimeFrame,iTime(NULL,next_tf,up_fract));
      left_shift=iHighest(NULL,TimeFrame,MODE_HIGH,left_shift,0);
      right_shift=iLowest(NULL,TimeFrame,MODE_LOW,left_shift,0);
      if(TrendLine(_DOWN_TREND_,right_shift,left_shift))
         trend=_DOWN_TREND_;
   }
   return(0);
  }
//+------------------------------------------------------------------+